'///////////////////////////////////////////////////////////
'/// Title: Aim Ai Script
'///
'/// Author: John Horrisberger
'/// Purpose: To provide a simple/easier to use interface with aim
'/// Date: 5/08/09
'///
'///////////////////////////////////////////////////////////

'///////////////////////////////////////////////////////////
'/// Directions - 
'///	First make sure that the "Aim Device Name" is set to your "AOL Instant messenger Control" name 
'///	( Remember, case sensitive )
'///	
'///	Ignore the "Command" & "Device ID" Properties, they are for memory retention.
'///
'///	Just ask in complete sentences, or sentence fragments it doesnt really matter ( NOT, case Sensitive ). 
'///	The script searches through all possible devices, guessing on the best one. Which means you can guess
'///	on the device names too!
'///
'///	So I would suggest giving your devices descriptive names. Such as....
'///		Garden Lights - Back Garden
'///		Garden Lights - Front House / Drive
'///		Garden Lights - Pool Garden
'///		
'///	This Way when the script phrases your command it can find/differentiate the devices better.
'///	Like for example...
'///		Turn the pool Lights on
'///		Back Garden Lights off
'///
'///	something like "Garden Lights off", would give an initially unpredictable, but consistent result,
'///		( I Think its based on the order that you added the devices to housebot? )
'///
'///	You can also add more phases to the GreatingList, OkayList, ConfusedList, and SorryList variables in
'///	their respected Subs. Just separate each phase with ";" and everything else will be taken care of automatically.
'///
'///	Be VERY cautious of changing the "TrimWords" Variable, unless you ask questions using different words
'///   
'/// 
'/// Example Commands - 
'///
'/// 	Weather - For a quick weather listings, ( You MUST have the Yahoo weather script device, Just set the name in 
'///			the "Weather Device Name" property, else leave blank
'///			I did this because I changed the name of mine to "System - CURRENTWEATHER" 
'///			and thought it was wasteful to search for it every time, but idk)
'///
'/// 	On / Turn on - Ex: Turn on the fans, or Could you turn the red lamp on, or fans on.
'/// 	Off / Turn off - Ex: Would you turn the red lamp off, or Pool lights off, garden lights off.
'/// 	Status - Ex: Whats the status of the fans, check the pool pump, or Fans (simply the device name ).
'/// 	List - Replies a list of all possible devices, with power states ( if they have them ).
'/// 	Hello / Hey / Hi - Just to grab my attention.
'///
'/// Comments - 
'/// 	Personally I like to think of this thing as a pet butler ( such as my dog Scout ) rather than a person because,
'///	I find i am more forgiving to my pet (dog) than I am to a person, and I find my expectations are set as such. 
'///	I also like to think this is due to the scripts limited/random vocab. lol
'///
'///	There is no "dimming"/"direct dimming" as of yet.
'///	Only support for devices with "Power State" & "State" Properties so far. Just been thinking on how to make that
'///		code cleaner
'///
'///	Let me know if any know it any of this is wanted or anything else.
'///
'/// 	More to Come!!!
'///
'//////////////////////////////////////////////////////////

Dim AimDeviceName, WeatherDeviceName
Dim ReceivedMsg, SentFrom, MsgtoSend, DeviceID, Property
Dim max, Random
Dim Device, DeviceList, DeviceLength,  PropertyList, TrimWords
Dim Temp
Dim GreatingList, OkayList, ConfusedList, SorryList
Dim PeopleRF

'Retrive Variables
AimDeviceName = GetPropertyValue(".Aim Device Name")
WeatherDeviceName = GetPropertyValue(".Weather Device Name")
SentFrom = LCase(GetPropertyValue(AimDeviceName & ".Sent From"))
ReceivedMsg = LCase(GetPropertyValue(AimDeviceName & ".Received Message"))

Main

Private Sub Main()
	
	PeopleReceivdFrom

	If ( ReceivedMsg = "hey" or ReceivedMsg = "hello" or ReceivedMsg = "hi" ) Then
		Greating
	ElseIf ( ReceivedMsg = "yes" or ReceivedMsg = "no" ) Then
		Execute
	ElseIf ( ReceivedMsg = "list" ) Then
		List
	ElseIf ( InStr(ReceivedMsg,"weather") ) Then
		weather
	Else
		Thinker
	End if

	SetHouseBotValues
End Sub

' Greating _________________________________________________________________________________________

Private Sub Greating
	GreatingList = split("Hey;how may I help?;What ya need? :);Hello, how may I be of Assistance?;How can I help?;yep, I'm here;whats up;yo;what do you require assistance with?", ";")
	Max = Ubound(GreatingList)	
	Randomize
	Random = Int((max)*Rnd)	
	MsgtoSend = GreatingList(Random)	
End Sub

' Okay _____________________________________________________________________________________________

Private Sub Okay
	OkayList = split( "Ok;Ok then :-);understood;okay;acknowledged;got it", ";" )
	Max = Ubound(OkayList)	
	Randomize
	Random = Int((max)*Rnd)	
	MsgtoSend = OkayList(Random)
End Sub

' Confused _________________________________________________________________________________________

Private Sub Confused
	ConfusedList =split( "what?;umm, I don't know what you mean;hmmm. thats new;Say again;huh?;ummm?;could you rephrase?", ";" )
	Max = Ubound(ConfusedList)	
	Randomize		
	Random = Int((max)*Rnd)	
	MsgtoSend = ConfusedList(Random)
End Sub

' Sorry _____________________________________________________________________________________________

Private Sub Sorry
	SorryList =split( "Sorry that device is not controable;This is not posible over aim;Sorry you can't change that;Sorry, this isn't controllable;You can't change that sorry;You can't change that device, maybe you ment something else?", ";" )
	Max = Ubound(SorryList)	
	Randomize		
	Random = Int((max)*Rnd)	
	MsgtoSend = SorryList(Random)
End Sub

Private Sub Weather
	MsgtoSend = VbCrLf & "Date: " & GetPropertyValue(WeatherDeviceName & ".CWDate") & vbCrLf & "Current Forecasted Weather: " & GetPropertyValue(WeatherDeviceName & ".CWForecastWeather") & VbCrLf & "Current Weather: " & GetPropertyValue(WeatherDeviceName & ".CWWeather") & VbCrLf & "Current Temperature: " & GetPropertyValue(WeatherDeviceName & ".CWTemperature") & VbCrLf & "High/Low: " & GetPropertyValue(WeatherDeviceName & ".CWHigh") & " / " & GetPropertyValue(WeatherDeviceName & ".CWLow")
End Sub


' Thinker ____________________________________________________________________________________________
Private Sub Thinker
	If ( StrComp(Right(ReceivedMsg,2), "on") = 0 or InStr(ReceivedMsg, "turn on")) Then         
	Property = "On"
	ElseIF ( StrComp(Right(ReceivedMsg,3), "off") = 0 or InStr(ReceivedMsg, "turn off") or InStr(ReceivedMsg, "shut off") ) Then
	Property = "Off"
	End If

	TrimWords = split(" on, off, status, the,turn,whats,what, is, of,',hey,could, you,can,s,would,shut,get, state,check", ",")
	For i = 0 to Ubound(TrimWords) 
		ReceivedMsg = Replace(ReceivedMsg,TrimWords(i),"", 1, -1, 1)
	Next

	ReceivedMsg = Trim(ReceivedMsg)

	Device = split(ReceivedMsg)
	DeviceList = Split(GetDeviceList(",&;"), ",&;")
	
	For i = 0 to Ubound(Device)
		If UBound(DeviceList) > 0 Then
			DeviceList = Filter(DeviceList, Device(i), true, 1)
		End If
	Next	


	If Ubound(DeviceList) >= 0 Then
		PropertyList = GetPropertyListForDevice(DeviceList(0), ",")
		
		If InStr(1, PropertyList, "Power State", 1)  Then
			DeviceID = DeviceList(0) & ".Power State"
			If Property = "On" Then
				Device = SetPropertyValue(DeviceList(0) & ".Power State", "On")
				MsgtoSend = "Ok, " & Chr(34) & DeviceList(0) & Chr(34) & " has been turned on"

			ElseIf Property = "Off" Then
				Device = SetPropertyValue(DeviceList(0) & ".Power State", "Off")
				MsgtoSend = "Ok, " & Chr(34) & DeviceList(0) & Chr(34) & " has been turned off"

			Else
				Device = GetPropertyValue(DeviceList(0) & ".Power State")
				MsgtoSend = "The " & Chr(34) & DeviceList(0) & Chr(34) & " is " & Device
				If Device = "On" Then
					MsgtoSend =  MsgtoSend & ", Do you want it Off"
					Property = "Off"
				ElseIf Device = "Off" Then
					MsgtoSend =  MsgtoSend & ", Do you want it On"
					Property = "On"
				End If
				

			End If

		ElseIf InStr(1, PropertyList, "State", 1) Then
			DeviceID = DeviceList(0) & ".State"
			If Property = "On" Then
			Device = SetPropertyValue(DeviceList(0) & ".State", "Closed")
			MsgtoSend = "Ok, " & Chr(34) & DeviceList(0) & Chr(34) & " has been turned on"

			ElseIf Property = "Off" Then
			Device = SetPropertyValue(DeviceList(0) & ".State", "Opened")
			MsgtoSend = "Ok, " & Chr(34) & DeviceList(0) & Chr(34) & " has been turned off"

			Else
			Device = GetPropertyValue(DeviceList(0) & ".State")
				MsgtoSend = "The " & Chr(34) & DeviceList(0) & Chr(34) & " is " 
				If Device = "Closed" Then
					MsgtoSend =  MsgtoSend & "On, Do you want it Off"
					Property = "opened"
				ElseIf Device = "Opened" Then
					MsgtoSend =  MsgtoSend & "Off, Do you want it On"
					Property = "closed"
				End If
			End If
		Else
			Sorry
			
		End If
	Else	
		Confused

	End If

End Sub

'Execute _________________________________________________________________________________

Private Sub Execute
	If (GetPropertyValue(".Device ID")) <> "" Then
		If (ReceivedMsg = "yes") Then
			Temp = SetPropertyValue(GetPropertyValue(".Device ID"), GetPropertyValue(".Command"))
			Okay
		Elseif (ReceivedMsg = "no") Then
			Okay

		End If
	Else
		MsgtoSend = "I didn't ask you anything"
	End If

End Sub

' List ____________________________________________________________________________________

Private Sub List

DeviceList = Split(GetDeviceList(",&;"), ",&;")

dim i, j, temp
for i = UBound(DeviceList) - 1 To 0 Step -1
for j= 0 to i
if DeviceList(j)>DeviceList(j+1) then
temp=DeviceList(j+1)
DeviceList(j+1)=DeviceList(j)
DeviceList(j)=temp
end if
next
next

For i = 0 to Ubound(DeviceList)
	If (InStr(GetPropertyListForDevice(DeviceList(i), ","), "Power State")) Then
		DeviceList(i) = DeviceList(i) & " - " & GetPropertyValue(DeviceList(i) & ".Power State")
	End If
Next

MsgtoSend = Join(DeviceList,vbCrLf)
End Sub

' PeopleReceivdFrom __________________________________________________________________________

Private Sub PeopleReceivdFrom

	PeopleRF = LCase(GetPropertyValue(".People Received From"))

	If InStr( PeopleRF, SentFrom) = 0 Then
		PeopleRF = PeopleRF & "," & SentFrom 
	End If
End Sub

' SetHouseBotValues ___________________________________________________________________________

Private Sub SetHouseBotValues()
	Call SetPropertyValue(AimDeviceName & ".Recipient", SentFrom)
	
	If (MsgtoSend <> "NULL") Then
	Call SetPropertyValue(AimDeviceName & ".Message to Send", MsgtoSend)
	End If

	Call SetPropertyValue(".Device ID", DeviceID)
	Call SetPropertyValue(".Command", Property)
	Call SetPropertyValue(".People Received From", PeopleRF)

End Sub


